Index: palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/urban_surface_mod.f90	(revision 4670)
+++ palm/trunk/SOURCE/urban_surface_mod.f90	(revision 4671)
@@ -8617,36 +7284,41 @@
 
        CALL wrd_write_string( 'ns_h_on_file_usm' )
-       WRITE ( 14 )  surf_usm_h%ns
+       WRITE ( 14 )  surf_usm_h(0:1)%ns
 
        CALL wrd_write_string( 'ns_v_on_file_usm' )
        WRITE ( 14 )  surf_usm_v(0:3)%ns
 
-       CALL wrd_write_string( 'usm_start_index_h' )
-       WRITE ( 14 )  surf_usm_h%start_index
-
-       CALL wrd_write_string( 'usm_end_index_h' )
-       WRITE ( 14 )  surf_usm_h%end_index
-
-       CALL wrd_write_string( 't_surf_wall_h' )
-       WRITE ( 14 )  t_surf_wall_h
-
-       CALL wrd_write_string( 't_surf_window_h' )
-       WRITE ( 14 )  t_surf_window_h
-
-       CALL wrd_write_string( 't_surf_green_h' )
-       WRITE ( 14 )  t_surf_green_h
-
-       CALL wrd_write_string( 'm_liq_usm_h' )
-       WRITE ( 14 )  m_liq_usm_h%var_usm_1d
-!
-!--    Write restart data which is especially needed for the urban-surface model. In order to do not
-!--    fill up the restart routines in surface_mod. Output of waste heat from indoor model. Restart
-!--    data is required in this special case, because the indoor model, where waste heat is
-!--    computed, is called each hour (current default), so that waste heat would have zero value
-!--    until next call of indoor model.
-       IF ( indoor_model )  THEN
-          CALL wrd_write_string( 'waste_heat_h' )
-          WRITE ( 14 )  surf_usm_h%waste_heat
-       ENDIF
+       DO  l = 0, 1
+
+          CALL wrd_write_string( 'usm_start_index_h' )
+          WRITE ( 14 )  surf_usm_h(l)%start_index
+
+          CALL wrd_write_string( 'usm_end_index_h' )
+          WRITE ( 14 )  surf_usm_h(l)%end_index
+
+          WRITE( dum, '(I1)')  l
+
+          CALL wrd_write_string( 't_surf_wall_h(' // dum // ')' )
+          WRITE ( 14 )  t_surf_wall_h(l)%val
+
+          CALL wrd_write_string( 't_surf_window_h(' // dum // ')' )
+          WRITE ( 14 )  t_surf_window_h(l)%val
+
+          CALL wrd_write_string( 't_surf_green_h(' // dum // ')' )
+          WRITE ( 14 )  t_surf_green_h(l)%val
+
+          CALL wrd_write_string( 'm_liq_usm_h(' // dum // ')' )
+          WRITE ( 14 )  m_liq_usm_h(l)%val
+!
+!--       Write restart data which is especially needed for the urban-surface model. In order to do not
+!--       fill up the restart routines in surface_mod. Output of waste heat from indoor model. Restart
+!--       data is required in this special case, because the indoor model, where waste heat is
+!--       computed, is called each hour (current default), so that waste heat would have zero value
+!--       until next call of indoor model.
+          IF ( indoor_model )  THEN
+             CALL wrd_write_string( 'waste_heat_h(' // dum // ')' )
+             WRITE ( 14 )  surf_usm_h(l)%waste_heat
+          ENDIF
+       ENDDO
 
        DO  l = 0, 3
@@ -8661,11 +7333,11 @@
 
           CALL wrd_write_string( 't_surf_wall_v(' // dum // ')' )
-          WRITE ( 14 )  t_surf_wall_v(l)%t
+          WRITE ( 14 )  t_surf_wall_v(l)%val
 
           CALL wrd_write_string( 't_surf_window_v(' // dum // ')' )
-          WRITE ( 14 ) t_surf_window_v(l)%t
+          WRITE ( 14 ) t_surf_window_v(l)%val
 
           CALL wrd_write_string( 't_surf_green_v(' // dum // ')' )
-          WRITE ( 14 ) t_surf_green_v(l)%t
+          WRITE ( 14 ) t_surf_green_v(l)%val
 
           IF ( indoor_model )  THEN
@@ -8676,18 +7348,24 @@
        ENDDO
 
-       CALL wrd_write_string( 'usm_start_index_h' )
-       WRITE ( 14 )  surf_usm_h%start_index
-
-       CALL wrd_write_string( 'usm_end_index_h' )
-       WRITE ( 14 )  surf_usm_h%end_index
-
-       CALL wrd_write_string( 't_wall_h' )
-       WRITE ( 14 )  t_wall_h
-
-       CALL wrd_write_string( 't_window_h' )
-       WRITE ( 14 )  t_window_h
-
-       CALL wrd_write_string( 't_green_h' )
-       WRITE ( 14 )  t_green_h
+       DO  l = 0, 1
+
+          CALL wrd_write_string( 'usm_start_index_h' )
+          WRITE ( 14 )  surf_usm_h(l)%start_index
+
+          CALL wrd_write_string( 'usm_end_index_h' )
+          WRITE ( 14 )  surf_usm_h(l)%end_index
+
+          WRITE( dum, '(I1)')  l
+
+          CALL wrd_write_string( 't_wall_h(' // dum // ')' )
+          WRITE ( 14 )  t_wall_h(l)%val
+
+          CALL wrd_write_string( 't_window_h(' // dum // ')' )
+          WRITE ( 14 )  t_window_h(l)%val
+
+          CALL wrd_write_string( 't_green_h(' // dum // ')' )
+          WRITE ( 14 )  t_green_h(l)%val
+
+       ENDDO
 
        DO  l = 0, 3
@@ -8702,11 +7380,11 @@
 
           CALL wrd_write_string( 't_wall_v(' // dum // ')' )
-          WRITE ( 14 )  t_wall_v(l)%t
+          WRITE ( 14 )  t_wall_v(l)%val
 
           CALL wrd_write_string( 't_window_v(' // dum // ')' )
-          WRITE ( 14 )  t_window_v(l)%t
+          WRITE ( 14 )  t_window_v(l)%val
 
           CALL wrd_write_string( 't_green_v(' // dum // ')' )
-          WRITE ( 14 )  t_green_v(l)%t
+          WRITE ( 14 )  t_green_v(l)%val
 
        ENDDO
@@ -8716,19 +7394,24 @@
 !--    There is no information about the PE-grid necessary because the restart files consists of the
 !--    whole domain. Therefore, ns_h_on_file_usm and ns_v_on_file_usm are not used with MPI-IO.
-       CALL rd_mpi_io_surface_filetypes( surf_usm_h%start_index, surf_usm_h%end_index,             &
-                                         surface_data_to_write, global_start_index )
-
-       CALL wrd_mpi_io( 'usm_start_index_h',  surf_usm_h%start_index )
-       CALL wrd_mpi_io( 'usm_end_index_h', surf_usm_h%end_index )
-       CALL wrd_mpi_io( 'usm_global_start_h', global_start_index )
-
-       CALL wrd_mpi_io_surface( 't_surf_wall_h',  t_surf_wall_h )
-       CALL wrd_mpi_io_surface( 't_surf_window_h', t_surf_window_h )
-       CALL wrd_mpi_io_surface( 't_surf_green_h', t_surf_green_h )
-
-       CALL wrd_mpi_io_surface( 'm_liq_usm_h', m_liq_usm_h%var_usm_1d )
-       IF ( indoor_model )  THEN
-          CALL wrd_mpi_io_surface( 'waste_heat_h', surf_usm_h%waste_heat ) ! NEED TO BE CHECKED!!!!!
-       ENDIF
+       DO  l = 0, 1
+
+          WRITE( dum, '(I1)')  l
+
+          END DO
+          CALL rd_mpi_io_surface_filetypes( surf_usm_h(l)%start_index, surf_usm_h(l)%end_index,             &
+                                            surface_data_to_write, global_start_index )
+
+          CALL wrd_mpi_io( 'usm_start_index_h_' // dum,  surf_usm_h(l)%start_index )
+          CALL wrd_mpi_io( 'usm_end_index_h_' // dum, surf_usm_h(l)%end_index )
+          CALL wrd_mpi_io( 'usm_global_start_h_' // dum, global_start_index )
+
+          CALL wrd_mpi_io_surface( 't_surf_wall_h_' // dum,  t_surf_wall_h(l)%val )
+          CALL wrd_mpi_io_surface( 't_surf_window_h_' // dum, t_surf_window_h(l)%val )
+          CALL wrd_mpi_io_surface( 't_surf_green_h_' // dum, t_surf_green_h(l)%val )
+
+          CALL wrd_mpi_io_surface( 'm_liq_usm_h_' // dum, m_liq_usm_h(l)%val )
+          IF ( indoor_model )  THEN
+             CALL wrd_mpi_io_surface( 'waste_heat_h_' // dum, surf_usm_h(l)%waste_heat ) ! NEED TO BE CHECKED!!!!!
+          ENDIF
 
        DO  l = 0, 3
@@ -8745,20 +7428,26 @@
           IF ( .NOT. surface_data_to_write )  CYCLE
 
-          CALL wrd_mpi_io_surface( 't_surf_wall_v(' // dum // ')', t_surf_wall_v(l)%t )
-          CALL wrd_mpi_io_surface( 't_surf_window_v(' // dum // ')', t_surf_window_v(l)%t )
-          CALL wrd_mpi_io_surface( 't_surf_green_v(' // dum // ')', t_surf_green_v(l)%t )
+          CALL wrd_mpi_io_surface( 't_surf_wall_v(' // dum // ')', t_surf_wall_v(l)%val )
+          CALL wrd_mpi_io_surface( 't_surf_window_v(' // dum // ')', t_surf_window_v(l)%val )
+          CALL wrd_mpi_io_surface( 't_surf_green_v(' // dum // ')', t_surf_green_v(l)%val )
 
        ENDDO
 
-       CALL rd_mpi_io_surface_filetypes( surf_usm_h%start_index, surf_usm_h%end_index,             &
-                                         surface_data_to_write, global_start_index )
-
-       CALL wrd_mpi_io( 'usm_start_index_h_2',  surf_usm_h%start_index )
-       CALL wrd_mpi_io( 'usm_end_index_h_2', surf_usm_h%end_index )
-       CALL wrd_mpi_io( 'usm_global_start_h_2', global_start_index )
-
-       CALL wrd_mpi_io_surface( 't_wall_h', t_wall_h )
-       CALL wrd_mpi_io_surface( 't_window_h', t_window_h )
-       CALL wrd_mpi_io_surface( 't_green_h', t_green_h )
+       DO  l = 0, 1
+
+          WRITE( dum, '(I1)')  l
+
+          CALL rd_mpi_io_surface_filetypes( surf_usm_h(l)%start_index, surf_usm_h(l)%end_index,             &
+                                            surface_data_to_write, global_start_index )
+
+          CALL wrd_mpi_io( 'usm_start_index_h_2_' // dum,  surf_usm_h(l)%start_index )
+          CALL wrd_mpi_io( 'usm_end_index_h_2_' // dum, surf_usm_h(l)%end_index )
+          CALL wrd_mpi_io( 'usm_global_start_h_2_' // dum, global_start_index )
+
+          CALL wrd_mpi_io_surface( 't_wall_h_' // dum, t_wall_h(l)%val )
+          CALL wrd_mpi_io_surface( 't_window_h_' // dum, t_window_h(l)%val )
+          CALL wrd_mpi_io_surface( 't_green_h_' // dum, t_green_h(l)%val )
+
+       ENDDO
 
        DO  l = 0, 3
@@ -8775,7 +7464,7 @@
           IF ( .NOT. surface_data_to_write )  CYCLE
 
-          CALL wrd_mpi_io_surface( 't_wall_v(' // dum // ')', t_wall_v(l)%t )
-          CALL wrd_mpi_io_surface( 't_window_v(' // dum // ')', t_window_v(l)%t )
-          CALL wrd_mpi_io_surface( 't_green_v(' // dum // ')', t_green_v(l)%t )
+          CALL wrd_mpi_io_surface( 't_wall_v(' // dum // ')', t_wall_v(l)%val )
+          CALL wrd_mpi_io_surface( 't_window_v(' // dum // ')', t_window_v(l)%val )
+          CALL wrd_mpi_io_surface( 't_green_v(' // dum // ')', t_green_v(l)%val )
 
        ENDDO
Index: palm/trunk/SOURCE/virtual_measurement_mod.f90
===================================================================
--- palm/trunk/SOURCE/virtual_measurement_mod.f90	(revision 4670)
+++ palm/trunk/SOURCE/virtual_measurement_mod.f90	(revision 4671)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Implementation of downward facing USM and LSM surfaces
+!
+! 4645 2020-08-24 13:55:58Z suehring
 ! Bugfix in output of E_UTM_soil coordinate
 !
@@ -1201,8 +1204,8 @@
                 DO  j = nys, nyn
                    IF ( ANY( BTEST( meas_flag(:,j,i), 0 ) ) )  THEN
-                      IF ( surf_lsm_h%start_index(j,i) <= surf_lsm_h%end_index(j,i) )  THEN
+                      IF ( surf_lsm_h(0)%start_index(j,i) <= surf_lsm_h(0)%end_index(j,i) )  THEN
                          vmea(l)%ns_soil = vmea(l)%ns_soil + nzt_soil - nzb_soil + 1
                       ENDIF
-                      IF ( surf_usm_h%start_index(j,i) <= surf_usm_h%end_index(j,i) )  THEN
+                      IF ( surf_usm_h(0)%start_index(j,i) <= surf_usm_h(0)%end_index(j,i) )  THEN
                          vmea(l)%ns_soil = vmea(l)%ns_soil + nzt_wall - nzb_wall + 1
                       ENDIF
@@ -1226,6 +1229,6 @@
                 DO  j = nys, nyn
                    IF ( ANY( BTEST( meas_flag(:,j,i), 0 ) ) )  THEN
-                      IF ( surf_lsm_h%start_index(j,i) <= surf_lsm_h%end_index(j,i) )  THEN
-                         m = surf_lsm_h%start_index(j,i)
+                      IF ( surf_lsm_h(0)%start_index(j,i) <= surf_lsm_h(0)%end_index(j,i) )  THEN
+                         m = surf_lsm_h(0)%start_index(j,i)
                          DO  k = nzb_soil, nzt_soil
                             ns = ns + 1
@@ -1237,6 +1240,6 @@
                       ENDIF
 
-                      IF ( surf_usm_h%start_index(j,i) <= surf_usm_h%end_index(j,i) )  THEN
-                         m = surf_usm_h%start_index(j,i)
+                      IF ( surf_usm_h(0)%start_index(j,i) <= surf_usm_h(0)%end_index(j,i) )  THEN
+                         m = surf_usm_h(0)%start_index(j,i)
                          DO  k = nzb_wall, nzt_wall
                             ns = ns + 1
@@ -1244,5 +1247,5 @@
                             vmea(l)%j_soil(ns) = j
                             vmea(l)%k_soil(ns) = k
-                            vmea(l)%depth(ns)  = - surf_usm_h%zw(k,m)
+                            vmea(l)%depth(ns)  = - surf_usm_h(0)%zw(k,m)
                          ENDDO
                       ENDIF
@@ -2552,9 +2555,9 @@
                        vmea(l)%measured_vars(m,n) = surf_def_h(0)%us(mm)
                     ENDDO
-                    DO  mm = surf_lsm_h%start_index(j,i), surf_lsm_h%end_index(j,i)
-                       vmea(l)%measured_vars(m,n) = surf_lsm_h%us(mm)
-                    ENDDO
-                    DO  mm = surf_usm_h%start_index(j,i), surf_usm_h%end_index(j,i)
-                       vmea(l)%measured_vars(m,n) = surf_usm_h%us(mm)
+                    DO  mm = surf_lsm_h(0)%start_index(j,i), surf_lsm_h(0)%end_index(j,i)
+                       vmea(l)%measured_vars(m,n) = surf_lsm_h(0)%us(mm)
+                    ENDDO
+                    DO  mm = surf_usm_h(0)%start_index(j,i), surf_usm_h(0)%end_index(j,i)
+                       vmea(l)%measured_vars(m,n) = surf_usm_h(0)%us(mm)
                     ENDDO
                  ENDDO
@@ -2573,9 +2576,9 @@
                        vmea(l)%measured_vars(m,n) = surf_def_h(0)%ts(mm)
                     ENDDO
-                    DO  mm = surf_lsm_h%start_index(j,i), surf_lsm_h%end_index(j,i)
-                       vmea(l)%measured_vars(m,n) = surf_lsm_h%ts(mm)
-                    ENDDO
-                    DO  mm = surf_usm_h%start_index(j,i), surf_usm_h%end_index(j,i)
-                       vmea(l)%measured_vars(m,n) = surf_usm_h%ts(mm)
+                    DO  mm = surf_lsm_h(0)%start_index(j,i), surf_lsm_h(0)%end_index(j,i)
+                       vmea(l)%measured_vars(m,n) = surf_lsm_h(0)%ts(mm)
+                    ENDDO
+                    DO  mm = surf_usm_h(0)%start_index(j,i), surf_usm_h(0)%end_index(j,i)
+                       vmea(l)%measured_vars(m,n) = surf_usm_h(0)%ts(mm)
                     ENDDO
                  ENDDO
@@ -2594,9 +2597,9 @@
                        vmea(l)%measured_vars(m,n) = surf_def_h(0)%qsws(mm)
                     ENDDO
-                    DO  mm = surf_lsm_h%start_index(j,i), surf_lsm_h%end_index(j,i)
-                       vmea(l)%measured_vars(m,n) = surf_lsm_h%qsws(mm)
-                    ENDDO
-                    DO  mm = surf_usm_h%start_index(j,i), surf_usm_h%end_index(j,i)
-                       vmea(l)%measured_vars(m,n) = surf_usm_h%qsws(mm)
+                    DO  mm = surf_lsm_h(0)%start_index(j,i), surf_lsm_h(0)%end_index(j,i)
+                       vmea(l)%measured_vars(m,n) = surf_lsm_h(0)%qsws(mm)
+                    ENDDO
+                    DO  mm = surf_usm_h(0)%start_index(j,i), surf_usm_h(0)%end_index(j,i)
+                       vmea(l)%measured_vars(m,n) = surf_usm_h(0)%qsws(mm)
                     ENDDO
                  ENDDO
@@ -2615,9 +2618,9 @@
                        vmea(l)%measured_vars(m,n) = surf_def_h(0)%shf(mm)
                     ENDDO
-                    DO  mm = surf_lsm_h%start_index(j,i), surf_lsm_h%end_index(j,i)
-                       vmea(l)%measured_vars(m,n) = surf_lsm_h%shf(mm)
-                    ENDDO
-                    DO  mm = surf_usm_h%start_index(j,i), surf_usm_h%end_index(j,i)
-                       vmea(l)%measured_vars(m,n) = surf_usm_h%shf(mm)
+                    DO  mm = surf_lsm_h(0)%start_index(j,i), surf_lsm_h(0)%end_index(j,i)
+                       vmea(l)%measured_vars(m,n) = surf_lsm_h(0)%shf(mm)
+                    ENDDO
+                    DO  mm = surf_usm_h(0)%start_index(j,i), surf_usm_h(0)%end_index(j,i)
+                       vmea(l)%measured_vars(m,n) = surf_usm_h(0)%shf(mm)
                     ENDDO
                  ENDDO
@@ -2633,6 +2636,6 @@
                     i = MERGE( i           , nxr, i            < nxr )
 
-                    DO  mm = surf_lsm_h%start_index(j,i), surf_lsm_h%end_index(j,i)
-                       vmea(l)%measured_vars(m,n) = surf_lsm_h%ghf(mm)
+                    DO  mm = surf_lsm_h(0)%start_index(j,i), surf_lsm_h(0)%end_index(j,i)
+                       vmea(l)%measured_vars(m,n) = surf_lsm_h(0)%ghf(mm)
                     ENDDO
                  ENDDO
@@ -2648,5 +2651,5 @@
 !                     i = MERGE( i           , nxr, i            < nxr )
 !
-!                     DO  mm = surf_lsm_h%start_index(j,i), surf_lsm_h%end_index(j,i)
+!                     DO  mm = surf_lsm_h(0)%start_index(j,i), surf_lsm_h(0)%end_index(j,i)
 !                        vmea(l)%measured_vars(m,n) = ?
 !                     ENDDO
@@ -2664,9 +2667,9 @@
                        i = MERGE( i           , nxr, i            < nxr )
 
-                       DO  mm = surf_lsm_h%start_index(j,i), surf_lsm_h%end_index(j,i)
-                          vmea(l)%measured_vars(m,n) = surf_lsm_h%rad_net(mm)
+                       DO  mm = surf_lsm_h(0)%start_index(j,i), surf_lsm_h(0)%end_index(j,i)
+                          vmea(l)%measured_vars(m,n) = surf_lsm_h(0)%rad_net(mm)
                        ENDDO
-                       DO  mm = surf_usm_h%start_index(j,i), surf_usm_h%end_index(j,i)
-                          vmea(l)%measured_vars(m,n) = surf_usm_h%rad_net(mm)
+                       DO  mm = surf_usm_h(0)%start_index(j,i), surf_usm_h(0)%end_index(j,i)
+                          vmea(l)%measured_vars(m,n) = surf_usm_h(0)%rad_net(mm)
                        ENDDO
                     ENDDO
@@ -2684,9 +2687,9 @@
                        i = MERGE( i           , nxr, i            < nxr )
 
-                       DO  mm = surf_lsm_h%start_index(j,i), surf_lsm_h%end_index(j,i)
-                          vmea(l)%measured_vars(m,n) = surf_lsm_h%rad_sw_out(mm)
+                       DO  mm = surf_lsm_h(0)%start_index(j,i), surf_lsm_h(0)%end_index(j,i)
+                          vmea(l)%measured_vars(m,n) = surf_lsm_h(0)%rad_sw_out(mm)
                        ENDDO
-                       DO  mm = surf_usm_h%start_index(j,i), surf_usm_h%end_index(j,i)
-                          vmea(l)%measured_vars(m,n) = surf_usm_h%rad_sw_out(mm)
+                       DO  mm = surf_usm_h(0)%start_index(j,i), surf_usm_h(0)%end_index(j,i)
+                          vmea(l)%measured_vars(m,n) = surf_usm_h(0)%rad_sw_out(mm)
                        ENDDO
                     ENDDO
@@ -2704,9 +2707,9 @@
                        i = MERGE( i           , nxr, i            < nxr )
 
-                       DO  mm = surf_lsm_h%start_index(j,i), surf_lsm_h%end_index(j,i)
-                          vmea(l)%measured_vars(m,n) = surf_lsm_h%rad_sw_in(mm)
+                       DO  mm = surf_lsm_h(0)%start_index(j,i), surf_lsm_h(0)%end_index(j,i)
+                          vmea(l)%measured_vars(m,n) = surf_lsm_h(0)%rad_sw_in(mm)
                        ENDDO
-                       DO  mm = surf_usm_h%start_index(j,i), surf_usm_h%end_index(j,i)
-                          vmea(l)%measured_vars(m,n) = surf_usm_h%rad_sw_in(mm)
+                       DO  mm = surf_usm_h(0)%start_index(j,i), surf_usm_h(0)%end_index(j,i)
+                          vmea(l)%measured_vars(m,n) = surf_usm_h(0)%rad_sw_in(mm)
                        ENDDO
                     ENDDO
@@ -2724,9 +2727,9 @@
                        i = MERGE( i           , nxr, i            < nxr )
 
-                       DO  mm = surf_lsm_h%start_index(j,i), surf_lsm_h%end_index(j,i)
-                          vmea(l)%measured_vars(m,n) = surf_lsm_h%rad_lw_out(mm)
+                       DO  mm = surf_lsm_h(0)%start_index(j,i), surf_lsm_h(0)%end_index(j,i)
+                          vmea(l)%measured_vars(m,n) = surf_lsm_h(0)%rad_lw_out(mm)
                        ENDDO
-                       DO  mm = surf_usm_h%start_index(j,i), surf_usm_h%end_index(j,i)
-                          vmea(l)%measured_vars(m,n) = surf_usm_h%rad_lw_out(mm)
+                       DO  mm = surf_usm_h(0)%start_index(j,i), surf_usm_h(0)%end_index(j,i)
+                          vmea(l)%measured_vars(m,n) = surf_usm_h(0)%rad_lw_out(mm)
                        ENDDO
                     ENDDO
@@ -2744,9 +2747,9 @@
                        i = MERGE( i           , nxr, i            < nxr )
 
-                       DO  mm = surf_lsm_h%start_index(j,i), surf_lsm_h%end_index(j,i)
-                          vmea(l)%measured_vars(m,n) = surf_lsm_h%rad_lw_in(mm)
+                       DO  mm = surf_lsm_h(0)%start_index(j,i), surf_lsm_h(0)%end_index(j,i)
+                          vmea(l)%measured_vars(m,n) = surf_lsm_h(0)%rad_lw_in(mm)
                        ENDDO
-                       DO  mm = surf_usm_h%start_index(j,i), surf_usm_h%end_index(j,i)
-                          vmea(l)%measured_vars(m,n) = surf_usm_h%rad_lw_in(mm)
+                       DO  mm = surf_usm_h(0)%start_index(j,i), surf_usm_h(0)%end_index(j,i)
+                          vmea(l)%measured_vars(m,n) = surf_usm_h(0)%rad_lw_in(mm)
                        ENDDO
                     ENDDO
@@ -2853,15 +2856,15 @@
                     k = vmea(l)%k_soil(m)
 
-                    match_lsm = surf_lsm_h%start_index(j,i) <= surf_lsm_h%end_index(j,i)
-                    match_usm = surf_usm_h%start_index(j,i) <= surf_usm_h%end_index(j,i)
+                    match_lsm = surf_lsm_h(0)%start_index(j,i) <= surf_lsm_h(0)%end_index(j,i)
+                    match_usm = surf_usm_h(0)%start_index(j,i) <= surf_usm_h(0)%end_index(j,i)
 
                     IF ( match_lsm )  THEN
-                       mm = surf_lsm_h%start_index(j,i)
-                       vmea(l)%measured_vars_soil(m,n) = t_soil_h%var_2d(k,mm)
+                       mm = surf_lsm_h(0)%start_index(j,i)
+                       vmea(l)%measured_vars_soil(m,n) = t_soil_h(0)%var_2d(k,mm)
                     ENDIF
 
                     IF ( match_usm )  THEN
-                       mm = surf_usm_h%start_index(j,i)
-                       vmea(l)%measured_vars_soil(m,n) = t_wall_h(k,mm)
+                       mm = surf_usm_h(0)%start_index(j,i)
+                       vmea(l)%measured_vars_soil(m,n) = t_wall_h(0)%val(k,mm)
                     ENDIF
                  ENDDO
@@ -2875,9 +2878,9 @@
                     k = vmea(l)%k_soil(m)
 
-                    match_lsm = surf_lsm_h%start_index(j,i) <= surf_lsm_h%end_index(j,i)
+                    match_lsm = surf_lsm_h(0)%start_index(j,i) <= surf_lsm_h(0)%end_index(j,i)
 
                     IF ( match_lsm )  THEN
-                       mm = surf_lsm_h%start_index(j,i)
-                       vmea(l)%measured_vars_soil(m,n) = m_soil_h%var_2d(k,mm)
+                       mm = surf_lsm_h(0)%start_index(j,i)
+                       vmea(l)%measured_vars_soil(m,n) = m_soil_h(0)%var_2d(k,mm)
                     ENDIF
 
@@ -2897,9 +2900,9 @@
                        vmea(l)%measured_vars(m,n) = surf_def_h(0)%pt_surface(mm)
                     ENDDO
-                    DO  mm = surf_lsm_h%start_index(j,i), surf_lsm_h%end_index(j,i)
-                       vmea(l)%measured_vars(m,n) = surf_lsm_h%pt_surface(mm)
-                    ENDDO
-                    DO  mm = surf_usm_h%start_index(j,i), surf_usm_h%end_index(j,i)
-                       vmea(l)%measured_vars(m,n) = surf_usm_h%pt_surface(mm)
+                    DO  mm = surf_lsm_h(0)%start_index(j,i), surf_lsm_h(0)%end_index(j,i)
+                       vmea(l)%measured_vars(m,n) = surf_lsm_h(0)%pt_surface(mm)
+                    ENDDO
+                    DO  mm = surf_usm_h(0)%start_index(j,i), surf_usm_h(0)%end_index(j,i)
+                       vmea(l)%measured_vars(m,n) = surf_usm_h(0)%pt_surface(mm)
                     ENDDO
                  ENDDO
@@ -2935,7 +2938,7 @@
                     i = MERGE( i           , nxr, i            < nxr )
 
-                    DO  mm = surf_lsm_h%start_index(j,i), surf_lsm_h%end_index(j,i)
-                       IF ( surf_lsm_h%water_surface(m) )                                          &
-                            vmea(l)%measured_vars(m,n) = t_soil_h%var_2d(nzt,m)
+                    DO  mm = surf_lsm_h(0)%start_index(j,i), surf_lsm_h(0)%end_index(j,i)
+                       IF ( surf_lsm_h(0)%water_surface(m) )                                          &
+                            vmea(l)%measured_vars(m,n) = t_soil_h(0)%var_2d(nzt,m)
                     ENDDO
 
Index: palm/trunk/SOURCE/write_restart_data_mod.f90
===================================================================
--- palm/trunk/SOURCE/write_restart_data_mod.f90	(revision 4670)
+++ palm/trunk/SOURCE/write_restart_data_mod.f90	(revision 4671)
@@ -19,9 +19,12 @@
 ! Current revisions:
 ! -----------------
-! 
-! 
+!
+!
 ! Former revisions:
 ! -----------------
 ! $Id$
+! Implementation of downward facing USM and LSM surfaces
+! 
+! 4564 2020-06-12 14:03:36Z raasch
 ! Vertical nesting method of Huq et al. (2019) removed
 ! 
@@ -184,5 +187,5 @@
     INTEGER ::  i                                !< loop index
 
-    binary_version_global = '5.0'
+    binary_version_global = '5.1'
 
     IF ( restart_data_format_output == 'fortran_binary' )  THEN
@@ -1161,5 +1164,5 @@
 !
 !-- Write arrays.
-    binary_version_local = '5.0'
+    binary_version_local = '5.1'
 
     IF ( TRIM( restart_data_format_output ) == 'fortran_binary' )  THEN
Index: palm/trunk/TESTS/cases/urban_environment/INPUT/urban_environment_p3d
===================================================================
--- palm/trunk/TESTS/cases/urban_environment/INPUT/urban_environment_p3d	(revision 4670)
+++ palm/trunk/TESTS/cases/urban_environment/INPUT/urban_environment_p3d	(revision 4671)
@@ -182,5 +182,4 @@
  &urban_surface_parameters
 
-    usm_material_model     = .T.,
     usm_wall_mod = .T.,
 
Index: palm/trunk/TESTS/cases/urban_environment_restart/INPUT/urban_environment_restart_p3dr
===================================================================
--- palm/trunk/TESTS/cases/urban_environment_restart/INPUT/urban_environment_restart_p3dr	(revision 4670)
+++ palm/trunk/TESTS/cases/urban_environment_restart/INPUT/urban_environment_restart_p3dr	(revision 4671)
@@ -181,5 +181,4 @@
  &urban_surface_parameters
 
-    usm_material_model     = .T.,
     usm_wall_mod = .T.,
 
Index: palm/trunk/TESTS/cases/urban_environment_salsa/INPUT/urban_environment_salsa_p3d
===================================================================
--- palm/trunk/TESTS/cases/urban_environment_salsa/INPUT/urban_environment_salsa_p3d	(revision 4670)
+++ palm/trunk/TESTS/cases/urban_environment_salsa/INPUT/urban_environment_salsa_p3d	(revision 4671)
@@ -167,5 +167,4 @@
  &urban_surface_parameters
 
-    usm_material_model     = .T.,
     usm_wall_mod = .T.,
 
